<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class AgeingAnalysis extends Model
{
    use HasFactory;

    protected $fillable = [
        'age_code',
        'description',
        'ageing_group',
        'interval_type',
        'interval',
        'custom_intervals',
        'custom_age_groups',
    ];

    protected $casts = [
        'custom_intervals' => 'array',
        'custom_age_groups' => 'array',
    ];
}
